<style src="./Pipeline.scss" lang="scss" scoped></style>
<script src="./Pipeline.js"></script>

<template>
  <div class="pipeline-page position-relative">
    <div
      style="overflow-x: auto; overflow-y: hidden; padding-bottom: 10px"
      class="d-flex nt-scroll-primary h-100"
    >
      <div v-for="(data, index) in transactions" :key="index" class="p-box d-flex flex-column">
        <div
          class="p-box_header d-flex align-items-baseline"
          :style="{ 'border-top-color': data.borderTopColor }"
        >
          <div style="flex: 1; margin-right: 10px">
            <div class="d-flex align-items-center justify-content-between p-box_header_title">
              <div :style="{ color: data.color }">{{ data.colName }}</div>
              <div
                data-toggle="m-tooltip"
                :data-original-title="'Số giao dịch ' + data.colName + ' trên tổng số giao dịch.'"
              >{{ getRates(data.numberOfTransaction) | percentage(2) }}</div>
            </div>
            <div class="d-flex align-items-center justify-content-between p-box_header_desc">
              <div>{{ data.numberOfTransaction }} giao dịch</div>
              <div>{{ Math.trunc(data.totalMoneys) | formatNumberPrice }}</div>
            </div>
          </div>
          <div
            class="m-dropdown m-dropdown--arrow m-dropdown--align-right"
            m-dropdown-toggle="click"
          >
            <div class="m-dropdown__toggle d-flex align-items-center justify-content-center">
              <i class="fas fa-sort"></i>
            </div>
            <div class="m-dropdown__wrapper">
              <div class="m-dropdown__inner">
                <div class="m-dropdown__body">
                  <div class="m-dropdown__body_header">Sắp xếp theo</div>
                  <div class="m-dropdown__body_body">
                    <div
                      class="m-dropdown__body_body_item d-flex align-items-center justify-content-between"
                      :class="{ 'active': option === selectedSortOption(data) }"
                      v-for="(option, indexB) in sortValues()"
                      :key="indexB"
                      @click="data.sortOption = option; onSort(indexB, data)"
                    >
                      <div class="d-flex align-items-center" v-html="option"></div>
                      <i class="fas fa-check"></i>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="position-relative h-100">
          <div
            v-if="!data.deals.length && data.canShowNoResult"
            class="centering"
            style="font-weight: 500; font-size: 14px; line-height: 21px; color: #444F78"
          >Chưa có giao dịch nào</div>
          <Loading :is_loader="data.isLoading" />
          <draggable
            class="p-box_body nt-scroll-primary"
            ghost-class="sortable-ghost"
            animation="150"
            :sort="false"
            :group="{ name: 'pipeline', pull: canPull(data.colName) }"
            :list="data.deals"
            @choose="onChoose(index, data.colName)"
            @unchoose="onUnchoose"
            @add="onAdd(data.colName, $event)"
          >
            <div
              class="p-box_body_item"
              :class="{ 'disabled': item.isLoading }"
              v-for="(item, indexA) in data.deals"
              :key="indexA"
              :id="item.id"
            >
              <div class="position-relative">
                <Loading :is_loader="item.isLoading" />
                <div class="upper">
                  <div class="d-flex align-items-center justify-content-between name">
                    <div>
                      <router-link
                        class="nt-link"
                        data-toggle="m-tooltip"
                        target="_blank"
                        :to="{ name: 'dealDetail', params: { team_id: currentTeam.team_id, deal_id: item.id }}"
                        :data-original-title="item.name"
                      >{{ item.name | truncateText(25) }}</router-link>
                      <router-link
                        class="icon icon-external-link-01"
                        target="_blank"
                        :to="{ name: 'dealDetail', params: { team_id: currentTeam.team_id, deal_id: item.id }}"
                      ></router-link>
                    </div>
                    <div
                      class="status d-flex align-items-center justify-content-center"
                      :class="getPaymentStatusClass(item.status)"
                      data-toggle="m-tooltip"
                      :data-original-title="statusTooltip(item.status)"
                    >
                      <i class="fas fa-dollar-sign"></i>
                    </div>
                  </div>
                  <div class="d-flex align-items-center upper_header">
                    <div class="upper_item">Khách hàng</div>
                    <div class="upper_item">Người phụ trách</div>
                  </div>
                  <div class="d-flex align-items-center uppper_desc">
                    <div
                      class="upper_item customer"
                      data-toggle="m-tooltip"
                      :data-original-title="item.customer"
                    >{{ item.customer | truncateText(15) }}</div>
                    <div class="upper_item d-flex">
                      <div
                        class="charger"
                        data-toggle="m-tooltip"
                        :data-original-title="getAssigner(item.assigner)"
                      >{{ getAssigner(item.assigner) | truncateText(14) }}</div>
                    </div>
                  </div>
                </div>
                <div class="lower d-flex align-items-center">
                  <div class="lower_item d-flex align-items-center">
                    <i class="icon icon-barcode-1"></i>
                    {{ item.code }}
                  </div>
                  <div class="lower_item d-flex align-items-center">
                    <i class="icon icon-money1"></i>
                    {{ Math.trunc(item.money) | formatNumberPrice }}
                  </div>
                </div>
              </div>
            </div>
            <infinite-loading @infinite="fetchDeals(data, $event)">
              <span slot="no-more"></span>
              <span slot="no-results"></span>
            </infinite-loading>
          </draggable>
        </div>
      </div>
    </div>
    <div :ref="'drag' + uid" class="p-footer d-flex align-items-center justify-content-center">
      <template v-for="(area, index) in dropAreas()">
        <draggable
          class="p-footer_item position-relative"
          :class="area.class"
          :key="index"
          group="pipeline"
          :list="list"
          @add="onAdd(area.colName, $event)"
        >
          <div class="centering w-100 text-center">{{ area.colName }}</div>
        </draggable>
      </template>
    </div>
    <Confirmation
      :id="uid"
      :showButton="confirmation.showButton"
      :confirmText="confirmation.confirmText"
      :cancelText="confirmation.cancelText"
      :content="confirmation.content"
      @confirmed="onConfirmed"
      @cancel="onCanceled"
    />
    <span :ref="'span' + uid" data-toggle="modal" :href="'#' + uid"></span>
    <CancelModal :id="uid + 'Modal'" @confirmed="onUpdateStatus" @cancel="onDismiss" />
    <span :ref="'modal' + uid" data-toggle="modal" :href="'#' + uid + 'Modal'"></span>
  </div>
</template>